<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.enterprisestaff_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="examine" slot-scope="scope">
        <span v-if="scope.row.examine===0" style="color: #2b373d">待审核</span>
        <span v-if="scope.row.examine===1" style="color: limegreen">审核通过</span>
        <span v-if="scope.row.examine===2" style="color: red">审核不通过</span>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/person/enterprisestaff";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          addBtn:false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "姓名",
              prop: "realName",
              editDisplay:false,
              search: true,
              rules: [{
                required: true,
                message: "请输入性名",
                trigger: "blur"
              }]
            },
            {
              label: "所属企业",
              prop: "enterpriseId",
              type: "select",
              width: 160,
              search: true,
              searchSpan: 6,
              overHidden: true,
              dicUrl: '/api/cyzh-enterprise/staff/list',
              dicFormatter: (res)=>{
                return res.data.records;
              },
              props: {
                label: "enterpriseName",
                value: "enterpriseId"
              },
              rules: [{
                required: true,
                message: "请输入所属企业",
                trigger: "blur"
              }]
            },
            {
              label: "脸部照片",
              prop: "face",
              type: "upload",
              width: 150,
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              action: "/api/blade-resource/oss/endpoint/put-file",
              tip: '只能生产jpg/png图片，且不超过500kb'
            },
            // {
            //   label: "企业名称",
            //   prop: "enterpriseName",
            //   rules: [{
            //     required: true,
            //     message: "请输入企业名称",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "所属园区",
              prop: "agencyId",
              search: true,
              cascaderItem: ['residentialId'],
              type: "select",
              remote: true,
              dicUrl: "/api/cyzh-community/agency/list",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择所属社区",
                trigger: "blur"
              }]
            },
            {
              label: "所属区域",
              prop: "residentialId",
              type: "select",
              search: true,
              cascaderItem: ['buildingId'],
              dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "员工编号",
              prop: "code",
              hide:true,
              rules: [{
                required: true,
                message: "请输入用户编号",
                trigger: "blur"
              }]
            },
            {
              label: "角色",
              prop: "role",
              hide:true,
              rules: [{
                required: true,
                message: "请输入角色id",
                trigger: "blur"
              }]
            },
            {
              label: "部门",
              prop: "dept",
              hide:true,
              rules: [{
                required: true,
                message: "请输入部门id",
                trigger: "blur"
              }]
            },
            {
              label: "岗位",
              prop: "post",
              hide:true,
              rules: [{
                required: true,
                message: "请输入岗位id",
                trigger: "blur"
              }]
            },
            {
              label: "来访目的",
              prop: "visitPurpose",
              hide:true,
              rules: [{
                required: true,
                message: "请输入来访目的",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "remarks",
              hide:true,
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
            {
              label:"审核状态",
              prop:"examine",
              search:"true",
              searchSpan: 4,
              slot:true,
              display: false,
              type:'select',
              dicData:[
                {
                  label:'待审核',
                  value:0,
                  color:'red'
                },{
                  label:'审核通过',
                  value:1
                },{
                  label:'审核不通过',
                  value:2
                }
              ]
            },
            {
              label: "住址",
              prop: "address",
              rules: [{
                required: true,
                message: "请输入住址",
                trigger: "blur"
              }]
            },
            {
              label: "审核意见",
              prop: "opinion",
              rules: [{
                required: true,
                message: "请输入审核意见",
                trigger: "blur"
              }]
            },
            {
              label:"来源",
              prop:"createType",
              search:"true",
              searchSpan: 4,
              type:'select',
              display: false,
              dicData:[
                {
                  label:'后台',
                  value:0
                },{
                  label:'小程序',
                  value:1
                }
              ]
            },
            {
              label: "审核时间",
              prop: "auditTime",
              rules: [{
                required: true,
                message: "请输入审核时间",
                trigger: "blur"
              }]
            },
            // {
            //   label: "是否为小程序园区管理员：0-否 1-是",
            //   prop: "isAgencyManager",
            //   rules: [{
            //     required: true,
            //     message: "请输入是否为小程序园区管理员：0-否 1-是",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "若为园区管理员时的小程序登录账号",
            //   prop: "agencyAccount",
            //   rules: [{
            //     required: true,
            //     message: "请输入若为园区管理员时的小程序登录账号",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "若为园区管理员时的小程序登录密码",
            //   prop: "agencyPassword",
            //   rules: [{
            //     required: true,
            //     message: "请输入若为园区管理员时的小程序登录密码",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "是否为企业管理员：0-否 1-是",
            //   prop: "isEnterpriseManager",
            //   rules: [{
            //     required: true,
            //     message: "请输入是否为企业管理员：0-否 1-是",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "若为企业管理员时的小程序登录账号",
            //   prop: "enterpriseAccount",
            //   rules: [{
            //     required: true,
            //     message: "请输入若为企业管理员时的小程序登录账号",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "若为企业管理员时的小程序登录密码",
            //   prop: "enterprisePassword",
            //   rules: [{
            //     required: true,
            //     message: "请输入若为企业管理员时的小程序登录密码",
            //     trigger: "blur"
            //   }]
            // },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.enterprisestaff_add, false),
          viewBtn: this.vaildData(this.permission.enterprisestaff_view, false),
          delBtn: this.vaildData(this.permission.enterprisestaff_delete, false),
          editBtn: this.vaildData(this.permission.enterprisestaff_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
